#include <iostream>
#include <cstdlib>

using namespace std;

class Test
{
protected:
	int a;
private:
	//Test(const Test& t){}
	//Test& operator=(const Test& t){return *this;}
public:
	Test(){a=5;}
	~Test(){}
};



void fonc(Test t)    // l3
{


}


int main()
{
	Test t,u;
	Test v(t);  // l1
	t = u;      // l2
	fonc(t);
	return 0;
}


/*!F 

  Le but de ce tuto est d'interdire la recopie d'une classe.
  Disons que vous voulez vous assurer que votre classe Test ne soit pas recopie :
  - si jamais il y a beaucoup de donnes dedans : perte de temps de recopie pour rien
  - Aucune raison de dupliquer la classe.
  - Peur de modifier une copie et non l'originale...
  - ...

  Vous dcidez donc d'empecher la classe de se recopier : on va voir comment faire dans ce prog.

  
  Voila un programme qui ne fait rien, mais qu'on va essayer de compiler.

  Compilez le tel quel : a marche.
  Combien de recopies ? --> 3 

  Vous recopiez t dans v via le constructeur par recopie (ligne l1)
  Vous recopiez u dans t vie l'oprateur = (ligne l2)
  Vous passez la classe en parametre par recopie (ligne l3)

  Voila, vous avez fait 3 recopies, et pourtant, elles ne sont pas aises a voir au premier coup d'oeil.
  Alors soit vous faites attention, soit vous activez les lignes :

  	//Test(const Test& t){}
	//Test& operator=(const Test& t){return *this;}

  qui sont en private dans la classe.
  en fait, j'ai donc dfini le constructeur par recopie et l'oprateur = dans la classe en private :
  du coup, on ne peut pas recopier la classe de l'extrieur.
  (peut importe ce que je mets dedans : de toute faon, je ne passez pas dedans.)

  Si vous compilez maintenant :

  les 3 recopies sont dtectes : le programme ne compile pas.
  Cela vous permet de dtecter les recopies.
  --> Quand il n'y aura plus d'erreurs : c'est que vous ne faites plus de recopies.

  Note :
  pour la fonction fonc, c'est une erreur classique : des recopies non attendues, a cause de l'oubli d'un "&" -> passage par rfrence


private VS protected:
*********************

  Mettre le constructeur par recopie et l'oprateur = en private ou en protected ?

  --> Et bien tout dpend si vous voulez que les classes filles de Test puissent se recopier ou non....

!*/

/*!E
	No explanations yet.
!*/

/*
titre: Interdire les recopies de classes.
titreE: Forbid class recopy.
meta: C++;pas de recopies
metaE: C++;no recopy
desc : Une scurit pour vous assurer que jamais votre classe ne sera recopie. 
descE : Prevent from unwanted recopy.
cle  : private
*/
